
.data
	freqTable	real4 261.626	; C
			real4 277.183	; C#
			real4 293.665	; D
			real4 311.127	; D#
			real4 329.628	; E
			real4 349.228	; F
			real4 369.994	; F#
			real4 391.995	; G
			real4 415.305	; G#
			real4 440.000	; A
			real4 466.164	; A#
			real4 493.883	; H

	szSTnote	db 'note',0
	szSTctrl	db 'control',0

	szRSrun		db 'Run',0
	szRSstop	db 'Stop',0

	dwSelected	dd 0
	lpChannel	dd ?

	lpFreqTable	dd ?
	seqCtrl		CANVAS <> 

	bpm		POT <120.0,60.0,180.0,0.5,2>
	shuffle		POT <0.0,0.0,1.0,0.05,2>
	tune		POT <0.0,-12.0,12.0,1.0,0>
	octave		POT <0.0,0.0,8.0,1.0,0>
	min		POT <0.0,-100.0,100.0,1.0,2>
	max		POT <0.0,-100.0,100.0,1.0,2>
	startButton	POT <0.0,0.0,1.0,1.0,1>
	_c60		CNST <<0.0,NULL>,0>
	_1		ADD2 <0.0,offset clock.fre,<offset bpm.fValue,0.0>,<offset _c60.fValue,0.0>>
	clock		OSC <0.0, offset oscImp, 0.0, 0, <offset startButton.fValue,0.0>, <offset _1.fValue,0.0>, <offset startButton.fValue,0.0>, <NULL,0.0>, 0, <0.0,0.0,0.0,0.0,0>, WF_IMP, 0, 0, OSC_ON, 0, NULL>

	seq1		SEQ164 <<0.0,offset seq164>, 0.0,0.0,0.0, <<offset startButton,0.0>,0.0>, <<offset clock,0.0>,0.0>, <>,<>,<>,<>>

.code
freqTableCreate		PROC USES esi edi

			invoke GlobalAlloc,GPTR,8*11*size real4		; space for 8 octaves
			mov	lpFreqTable,eax
			mov	esi,eax

			mov	edi,offset freqTable
			mov	ecx,8
		@@:
			fld	REAL4 PTR [edi]
			fld	st
			fdiv	f2
			fst	REAL4 PTR [esi+1*12*size real4]
			fdiv	f2
			fstp	REAL4 PTR [esi]
			fst	REAL4 PTR [esi]
			fmul	f2
			fst	REAL4 PTR [esi+2*12*size real4]
			fmul	f2
			fst	REAL4 PTR [esi+3*12*size real4]
			fmul	f2
			fst	REAL4 PTR [esi+4*12*size real4]
			fmul	f2
			fst	REAL4 PTR [esi+5*12*size real4]
			fmul	f2
			fst	REAL4 PTR [esi+6*12*size real4]
			fmul	f2
			fstp	REAL4 PTR [esi+7*12*size real4]

			add	esi,size real4
			add	edi,size real4
			sub	ecx,1
			jnz @B

			ret

freqTableCreate		ENDP


seqProc		PROC hDlg:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

		.IF uMsg==WM_INITDIALOG
			m2m	hPanel,hDlg
			invoke MoveWindow,hDlg,0,0,PANEL_SEQ_W,PANEL_SEQ_H,TRUE

			invoke setFloatInput,hDlg,IDC_BPM,NULL,offset bpm
			invoke displayValue,offset bpm,hDlg,IDC_BPM
			invoke setFloatInput,hDlg,IDC_SHUFFLE,NULL,offset shuffle
			invoke displayValue,offset shuffle,hDlg,IDC_SHUFFLE
			invoke setFloatInput,hDlg,IDC_TUNE,NULL,offset tune
			invoke displayValue,offset tune,hDlg,IDC_TUNE
			invoke setFloatInput,hDlg,IDC_OCTAVE,NULL,offset octave
			invoke displayValue,offset octave,hDlg,IDC_OCTAVE
			invoke setFloatInput,hDlg,IDC_MIN,NULL,offset min
			invoke displayValue,offset min,hDlg,IDC_MIN
			invoke setFloatInput,hDlg,IDC_MAX,NULL,offset max
			invoke displayValue,offset max,hDlg,IDC_MAX
			invoke SendDlgItemMessage,hDlg,IDC_TYPE,CB_ADDSTRING,0,offset szSTnote
			invoke SendDlgItemMessage,hDlg,IDC_TYPE,CB_ADDSTRING,0,offset szSTctrl

			mov	eax,offset szRSstop
			.IF startButton.fValue==0
				mov	eax,offset szRSrun
			.ENDIF
			invoke SendDlgItemMessage,hDlg,IDC_RUN,WM_SETTEXT,0,eax

			invoke displaySeqData,hDlg

;			mov	eax,dwSelected
;			imul	edx,eax,size CHANNEL
;			add	edx,offset seq1.data1
;			mov	lpChannel,edx
;			push	(CHANNEL PTR [edx]).dwType
;			add	eax,IDC_CHN1
;			invoke SendDlgItemMessage,hDlg,eax,BM_SETCHECK,BST_CHECKED,0
;			invoke SendDlgItemMessage,hDlg,IDC_TYPE,CB_SETCURSEL,DWORD PTR [esp+4],0
;			pop	eax
;			.IF eax==ST_NOTE
;				invoke SendDlgItemMessage,hDlg,IDC_MIN,WM_ENABLE,FALSE,0
;				invoke SendDlgItemMessage,hDlg,IDC_MAX,WM_ENABLE,FALSE,0
;			.ELSE
;				invoke SendDlgItemMessage,hDlg,IDC_TUNE,WM_ENABLE,FALSE,0
;			.ENDIF

			mov	seqCtrl.ID,IDC_SEQ
			m2m	seqCtrl.hParent,hDlg
			m2m	seqCtrl.hInstance,hInstance
			mov	seqCtrl.x,178
			mov	seqCtrl.y,1
			m2m	seqCtrl.w,512
			m2m	seqCtrl.h,128
			mov	seqCtrl.object,NULL
			m2m	seqCtrl.lpWndProc,offset seqCtrlProc
			invoke canvasCreate,offset seqCtrl
			xor	eax,eax
		.ELSEIF uMsg==WM_CLOSE
			invoke SendMessage,seqCtrl.hWnd,WM_CLOSE,0,0
			invoke EndDialog,hDlg,NULL


		.ELSEIF uMsg==WM_COMMAND
			.IF wParam>=IDC_CHN1 && wParam<=IDC_CHN4
				mov	eax,wParam
				sub	eax,IDC_CHN1
				mov	dwSelected,eax
					invoke displaySeqData,hDlg
			.ELSEIF wParam==IDC_RUN
				invoke toggleValue,offset startButton
				mov	eax,offset szRSstop
				.IF startButton.fValue==0
					mov	eax,offset szRSrun
				.ENDIF
				invoke SendDlgItemMessage,hDlg,IDC_RUN,WM_SETTEXT,0,eax
			.ELSEIF wParam==IDC_TYPE+10000h*CBN_SELCHANGE
				invoke SendMessage,lParam,CB_GETCURSEL,0,0
				mov	edx,lpChannel
				mov	(CHANNEL PTR [edx]).dwType,eax

				push	DWORD PTR TRUE
				push	DWORD PTR FALSE
				.IF eax==ST_NOTE
					mov	DWORD PTR [esp+4],FALSE
					mov	DWORD PTR [esp],TRUE
				.ENDIF
				invoke SendDlgItemMessage,hDlg,IDC_MIN,WM_ENABLE,[esp+8],0
				invoke SendDlgItemMessage,hDlg,IDC_MAX,WM_ENABLE,[esp+8],0
				invoke SendDlgItemMessage,hDlg,IDC_TUNE,WM_ENABLE,[esp+4],0
				invoke SendDlgItemMessage,hDlg,IDC_OCTAVE,WM_ENABLE,[esp+4],0
			.ELSEIF wParam==IDC_BPM+10000h*EN_CHANGE
				invoke SendMessage,lParam,WM_GETTEXT,10,lpStr
				invoke AtoR4,lpStr,offset bpm.fValue
			.ENDIF

		.ELSE
			xor	eax,eax
		.ENDIF

		ret
seqProc		ENDP

seqDraw		PROC hWnd:DWORD,lpSeq:DWORD

		mov	ecx,16
		xor	edx,edx
	@@:
		invoke sDrawLineV,edx,0,seqCtrl.h,COLOR_ACTIVE_GRIDLINE
		add	edx,32*4
		sub	ecx,1
		jnz @B

		ret
seqDraw		ENDP

seq164		PROC USES esi lpSeq164:PTR SEQ164
		mov	esi,lpSeq164
		ASSUME esi:PTR SEQ164
	
		ret
		ASSUME esi:NOTHING
seq164		ENDP

seqCtrlProc	PROC hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

		invoke canvasProc,hWnd,uMsg,wParam,lParam
		.IF uMsg==WM_SIZE
			jmp @Paint
		.ELSEIF uMsg==WM_PAINT
	@Paint: 	
			invoke sdStart,hWnd
			or 	eax,eax
			jz @End
				invoke canvasDrawBack,hWnd,512,32,128,8
				invoke seqDraw,hWnd,offset seq164
				invoke ValidateRect,hWnd,NULL
			invoke sdEnd
		.ELSE
			invoke	DefWindowProc,hWnd,uMsg,wParam,lParam
			ret
		.ENDIF
	@End:
		xor	eax,eax
		ret
seqCtrlProc	ENDP

displaySeqData	PROC hDlg:DWORD

		mov	eax,dwSelected
		imul	edx,eax,size CHANNEL
		add	edx,offset seq1.data1
		mov	lpChannel,edx
		push	(CHANNEL PTR [edx]).dwType
		add	eax,IDC_CHN1
		invoke SendDlgItemMessage,hDlg,eax,BM_SETCHECK,BST_CHECKED,0
		invoke SendDlgItemMessage,hDlg,IDC_TYPE,CB_SETCURSEL,DWORD PTR [esp+4],0
		pop	eax
		push	DWORD PTR TRUE
		push	DWORD PTR FALSE
		.IF eax==ST_NOTE
			mov	DWORD PTR [esp+4],FALSE
			mov	DWORD PTR [esp],TRUE
		.ENDIF
		invoke SendDlgItemMessage,hDlg,IDC_MIN,WM_ENABLE,[esp+8],0
		invoke SendDlgItemMessage,hDlg,IDC_MAX,WM_ENABLE,[esp+8],0
		invoke SendDlgItemMessage,hDlg,IDC_TUNE,WM_ENABLE,[esp+4],0
		invoke SendDlgItemMessage,hDlg,IDC_OCTAVE,WM_ENABLE,[esp+4],0

		ret
displaySeqData	ENDP